/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biojava1test;

/**
 *
 * @author caste
 */
import org.biojava.bio.symbol.*;
import org.biojava.bio.seq.*;
import java.util.*;

public class Ambiguity {
  public static void main(String[] args) {
    try {
      //get the DNA Alphabet
      Alphabet dna = DNATools.getDNA();

      //make the 'Y' symbol
      Set symbolsThatMakeY = new HashSet();
      symbolsThatMakeY.add(DNATools.c());
      symbolsThatMakeY.add(DNATools.t());
      Symbol y = dna.getAmbiguity(symbolsThatMakeY);    // Generates an Y symbol (i.e., a symbol related to c and t)

      //print information about 'Y' basis Symbol
      System.out.println("Formal name of 'Y' is: "+y.getName());
      System.out.println("Class type of 'Y' is: "+y.getClass().getName());

      //break the Y BasisSymbol into its component AtomicSymbols
      Alphabet matches = y.getMatches();    // Returns the Alphabet of Symbols related to y (c and t)
      System.out.print("The 'Y' Symbol is made of: ");

      //we know that there will be a finite set of matches so its ok to cast it
      for(Iterator i = ((FiniteAlphabet)matches).iterator(); i.hasNext();){
        Symbol sym = (Symbol)i.next();
        System.out.print(sym.getName());
        if(i.hasNext())
          System.out.print(", ");
      }
        System.out.println();
      
            //  getSymbols() returns the same result of getMatches()
      System.out.println("getSymbol result:");
      List l=((BasisSymbol)y).getSymbols();
      for(int i=0; i<l.size(); i++)
           System.out.println(((Symbol)l.get(i)).getName());
      System.out.println();


    }
    catch (IllegalSymbolException ex) {
      ex.printStackTrace();
    }
  }
}
