/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biojava1test;

/**
 *
 * @author caste
 */
import java.io.*;
import java.util.*;


import org.biojava.bio.dist.*;
import org.biojava.bio.seq.*;
import org.biojava.bio.seq.io.*;
import org.biojava.bio.symbol.*;

public class CountResidues {

  public static void main(String[] args) {
    //reference to object to hold the counts
    Count counts = null;

    try {
      String fileName = "ColiphagePhi-X174.fasta";

	// Set up sequence iterator
	BufferedReader br = new BufferedReader(new FileReader(fileName));
	SequenceIterator stream = SeqIOTools.readFastaDNA(br);


      //for each sequence
      while(stream.hasNext()){
        Sequence seq = stream.nextSequence();

        //if needed initialize counts
        if(counts == null){
          counts = new IndexedCount((FiniteAlphabet)seq.getAlphabet());     // Generate IndexCount for dna alphabet
        }

        //iterate through the Symbols in seq
        for (Iterator i = seq.iterator(); i.hasNext(); ) {
          AtomicSymbol sym = (AtomicSymbol)i.next();
          counts.increaseCount(sym,1.0);    // Increase by 1 the count of symbol sym
        }
      }

      //now print the results
      for (Iterator i = ((FiniteAlphabet)counts.getAlphabet()).iterator(); i.hasNext(); ) { // For each symbol of dna alphabet
        AtomicSymbol sym = (AtomicSymbol)i.next();
        System.out.println(sym.getName()+" : "+counts.getCount(sym));
      }
      System.out.println("");
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
}
