/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biojava1test;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Iterator;
import org.biojava.bio.Annotation;
import org.biojava.bio.seq.Feature;
import org.biojava.bio.seq.FeatureFilter;
import org.biojava.bio.seq.FeatureHolder;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.SequenceIterator;
import org.biojava.bio.seq.io.SeqIOTools;

/**
 *
 * @author caste
 */
public class GenBankAnnotationFeature {
    public static void main(String[] args) throws Exception {
        String fileName2 = "sequence.gb";
	BufferedReader br2 = new BufferedReader(new FileReader(fileName2));
	SequenceIterator stream2 = SeqIOTools.readGenbank(br2);

	// Iterate over all sequences in the stream
        Sequence seq=null;
        seq= stream2.nextSequence();

        System.out.println("Seq annotations:");
        Annotation seq2An = seq.getAnnotation();
        for (Iterator i = seq2An.keys().iterator(); i.hasNext(); ) {
            Object key = i.next();
            Object value = seq2An.getProperty(key);
            System.out.println(key.toString() + ": " + value.toString());
        }
        System.out.println();

        System.out.println("Features:");
        printFeatures(seq, "");
        System.out.println();

        //make a Filter for "CDS" types
        FeatureFilter ff = new FeatureFilter.ByType("CDS");

        //get the filtered Features
        FeatureHolder fh = seq.filter(ff);

        //iterate over the Features in fh

        System.out.println("CDS features");
        printFeatures(fh, "");
    }

    public static void printFeatures(FeatureHolder fh, String prefix) {
        for (Iterator i = fh.features(); i.hasNext(); ) {
            Feature f = (Feature) i.next();
            System.out.print(prefix);
            System.out.print(f.getType());
            System.out.print(" at ");
            System.out.println(f.getLocation().toString());
            //if(f.features()!=null)
                printFeatures(f, prefix + "    ");
        }
    }

}
