/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biojava1test;

import java.io.BufferedReader;
import java.io.FileReader;
import org.biojava.bio.seq.DNATools;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.SequenceIterator;
import org.biojava.bio.seq.io.SeqIOTools;
import org.biojava.bio.symbol.Symbol;

/**
 *
 * @author caste
 */
public class LoadFastaFile {
    public static void main(String[] args) throws Exception {
        // e.g. 4: load fasta file into Sequence object and compute cg-content
        String fileName = "ColiphagePhi-X174.fasta";

	// Set up sequence iterator
	BufferedReader br = new BufferedReader(new FileReader(fileName));
	SequenceIterator stream = SeqIOTools.readFastaDNA(br);

	// Iterate over all sequences in the stream
        Sequence seq1=null;
	while (stream.hasNext()) {
	    seq1=stream.nextSequence();
	    int gc = 0;
	    for (int pos = 1; pos <= seq1.length(); ++pos) {
		Symbol sym = seq1.symbolAt(pos);
		if (sym == DNATools.g() || sym == DNATools.c())
		    ++gc;
            }
            System.out.println("Sequence: "+seq1.getName() + ", "+seq1.getURN()+ ". gc: "+gc+", gc content:" + ((double)gc / seq1.length()*100) +"%, length: "+seq1.length());
            System.out.println(seq1.seqString().substring(0, 10)+"..."+seq1.seqString().substring(seq1.length()-10, seq1.length()));
	}
        System.out.println();
    }

}
