/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package biojava1test;

/**
 *
 * @author caste
 */
import org.biojava.bio.symbol.*;
import org.biojava.bio.seq.*;


public class TranscribeDNAtoRNA {
   public static void main(String[] args) {

      try {
       //make a DNA SymbolList
       SymbolList dna = DNATools.createDNA("atgccgaatcgtaa");

       //transcribe it to RNA
       SymbolList rna = DNATools.toRNA(dna);

       //just to prove it worked
       System.out.println("toRNA result: "+rna.seqString());

       //biological transcription (ie copy and reverse strand)
        rna = DNATools.transcribeToRNA(dna); //5’ atgccgaatcgtaa 3’
        System.out.println("transcribeToRNA result: "+rna.seqString()); //5’ uuacgauucggcau 3’
      }
      catch (IllegalSymbolException ex) {
        //this will happen if you try and make the DNA seq using non IUB symbols
         ex.printStackTrace();
      }catch (IllegalAlphabetException ex) {
       //this will happen if you try and transcribe a non DNA SymbolList
         ex.printStackTrace();
      }



   }
}
